# ResetHexRotations.py (Prototype 0.01)

# 0.00:
# 0.01: print statements changed to functions so it'll also work in Python 3 (Poser 12+), unnecessary Poser version try...except deleted, and FreazyPose comment removed from start


import poser,random

# I put my scripts into a class simply to avoid possible conflict with stuff in the __main__ module.
class cheapskatesTemporaryClass(object):
	def main(self):
			
		# Abort if the user gets cold feet right at the start
		confirmed = poser.DialogSimple.YesNo("This script resets hex rotations.\n\nDo you wish to continue?")
		if not confirmed:
			confirmed = poser.DialogSimple.YesNo("Do you want to see more information about what this script does?\n\n(This opens a debug window with extra information and terminates the script. You'll probably need to resize the debug window to read the information.)")
			if confirmed:
				# Briefly explain to the user what this script does and give an option toabort straight away
				print ("This script resets hex rotations... MORE EXPLANATION TO GO HERE")
			return
			
		# Abort if no figure selected
		scn = poser.Scene()
		curfig = scn.CurrentFigure()
		curact = scn.CurrentActor()
		if not curfig:
			poser.DialogSimple.MessageBox("You need to have a figure selected for this script to do anything.\n\nScript aborted, no changes made.")
			return
							
		# Abort if the currently selected actor is NOT part of the figure (parented props are NOT part of the figure)
		if not(curact.IsBodyPart() and curact.ItsFigure().Name()==curfig.Name()):
			poser.DialogSimple.MessageBox("The selected actor is not an integral part of the selected figure.\n\nScript aborted, no changes made.")
			return
		
		# Let user select random rortations in 1 or 60 degree steps (or skip)
		confirm1=poser.DialogSimple.YesNo("Reset y rotation for each hex?")
		if confirm1:
			
			i = 1
			while i < 38:
				if i < 10:
					bone = "subhex0" + str(i)
				else:
					bone = "subhex" + str(i)
				randyrot = 0
				print (bone + " y rotation set to " + str(randyrot))
				act = scn.ActorByInternalName(bone)
				act.Parameter("yRotate").SetValue(randyrot)
				i = i + 1
				
		# Redraw what we've modified	
		scn.Draw()
			
		# Inform the user that it's all done
		poser.DialogSimple.MessageBox("All done")
			
poser.DialogSimple.MessageBox("Running 3DCheapskates ResetHexRotations.py script (prototype 0.01)\n\n(N.B. You should see a similar message when the script finishes. If you don't then the script has crashed!)")
cheapskatesTemporaryInstance = cheapskatesTemporaryClass()
cheapskatesTemporaryInstance.main()
poser.DialogSimple.MessageBox("3DCheapskates ResetHexRotations.py script (prototype 0.01) all done.")